<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'ParallaxContainer',
  props: {
    offset: {
      type: Number,
      required: false,
      default: 0.1,
    },
    direction: {
      type: String,
      required: false,
      default: 'down',
      // up: content will translateY (+) up on scroll
      // down: content will translateY (-) down on scroll
    },
    threshold: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  data() {
    return {
      observer: null,
    };
  },
  computed: {
    getParallaxDirection() {
      return this.direction === 'down' ? '+' : '-';
    },
  },
  mounted() {
    const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
    if (!mediaQuery.matches) {
      this.observer = new IntersectionObserver(this.animationHandler, {
        rootMargin: '0px',
        threshold: this.threshold,
      });
      const children = this.$refs.container as HTMLElement;
      this.observer.observe(children);
    }
  },
  beforeDestroy() {
    this.observer.disconnect();
  },
  methods: {
    animationHandler(entries: any) {
      entries.forEach((entry: any) => {
        const element = entry.target;

        if (entry.isIntersecting) {
          document.addEventListener('scroll', () => {
            const distance = Number(window.scrollY);
            const elemDistanceFromTop = element.getBoundingClientRect().top;
            if ((distance - elemDistanceFromTop) * this.offset > 0) {
              element.style.transform = `translateY(${
                this.getParallaxDirection
              }${(distance - elemDistanceFromTop) * this.offset}px)`;
            }
          });
        }
      });
    },
  },
});
</script>

<template>
  <div ref="container" class="parallax-container">
    <slot></slot>
  </div>
</template>

<style lang="scss" scoped>
.parallax-container {
  width: 100%;
  height: 100%;
}
</style>
